{*
 * Projecte Fressa a LINKAT
 * FUNCIONS WIN 32
 *
 * Author Jordi Lagares Roset "jlagares@xtec.cat - www.lagares.org"
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (see the LICENSE file).
 *}

unit UnitCalcular;

{*******************************************************************************}
interface
{*******************************************************************************}

Const
  Operacions = 200;

Type
  PO= ^Oreal;
  Oreal= array[1..Operacions] of Real;
  Pc= ^cString;
  cString = array[0..Operacions] of string[3];

Procedure analitzar(StringAnalisis: String; var ErrorAnalisi,LlocErrorAnalisi: Integer);
Procedure Calcular(var xcReal: Real; var ycReal: Real; var ErrorCalcul: Integer);
Procedure CalcularXYZUV (x1,y1,z1,u1,v1: Real; var ycReal: Real; var ErrorCalcul: Integer);
Procedure DonarDades(var O3: OReal; var C3: CString; var NumeroOperacions: integer);
Procedure DonarOperacions(var O3: OReal; var C3: CString; var NumeroOperacions: integer);
function CalcularExpressio(StringExpressio:string):ShortString;
function CalcularExpressioResultat(StringExpressio:string):ShortString;
Procedure ProcCalcularExpressio(var StringExpressio:ShortString);
function CalcularCurrency(StringExpressio:string; var NumeroError:integer):single;
Procedure CanviarElsParametres(var StringAnalisis:String);

const
  NombreMaximDeParametres = 10;

var
 Parametres:array[1..NombreMaximDeParametres] of real;

{*******************************************************************************}
implementation
{*******************************************************************************}

uses sysutils, UnitTools;

var
  sen,gse,ase:string[4];

var
  O: Oreal;
  C: cString;
  O2: Oreal;
  C2: cString;
  Code: Integer;
  l, i, n, Nnp, Cnp, K: integer;
  ControlPunt: integer;
  LeftaS: string;
  iaS: string;
  StringiS: string;
  idS: string;
  a1S: String;
  Fallo: Integer;
  c1S: String;
  c2S: String;
  c3S: String;
  Ch1,Ch2: String[1];

Procedure CanviarElsParametres(var StringAnalisis:String);
var
  p:integer;
  j,k,l,m,n:string;
  HeDeFerBucle:boolean;
  s:string;
begin
  //A
  HeDeFerBucle:=true;
  while HeDeFerBucle do begin
    p:=Pos('A',StringAnalisis);
    if p<>0 then begin
      j:=Copy(StringAnalisis,p-2,1);
      k:=Copy(StringAnalisis,p-1,1);
      l:=Copy(StringAnalisis,p+1,1);
      m:=Copy(StringAnalisis,p+2,1);
      n:=Copy(StringAnalisis,p+3,1);
      if ((k='T') and (l='N')) or
       ((k='T') and (l='G')) or
       ((l='S') and (m='E')) or
       ((l='S') and (m='G')) or
       ((l='C') and (m='O') and (n='(')) or
       ((l='C') and (m='G')) or
       ((l='T') and (m='A')) or
       ((j='A') and (k='T')) or
       ((l='T') and (m='G')) or
       ((l='L') and (m='O')) or
       ((l='B') and (m='S'))
       then begin
        HeDeFerBucle:=false;
      end else begin
        Delete(StringAnalisis,p,1);
        if Parametres[1]>=0 then begin
          Insert(FToSToRealToString(Parametres[1]),StringAnalisis,p);
        end else begin
          Insert('(-1)*'+FToSToRealToString(abs(Parametres[1])),StringAnalisis,p);
        end;
      end;
    end else HeDeFerBucle:=false;
  end;
  //B
  HeDeFerBucle:=true;
  while HeDeFerBucle do begin
    p:=Pos('B',StringAnalisis);
    if p<>0 then begin
      j:=Copy(StringAnalisis,p-2,1);
      k:=Copy(StringAnalisis,p-1,1);
      l:=Copy(StringAnalisis,p+1,1);
      m:=Copy(StringAnalisis,p+2,1);
      n:=Copy(StringAnalisis,p+3,1);
      if ((l='S') and (m='(')) then begin
        HeDeFerBucle:=false;
      end else begin
        Delete(StringAnalisis,p,1);
        if Parametres[2]>=0 then begin
          Insert(FToSToRealToString(Parametres[2]),StringAnalisis,p);
        end else begin
          Insert('(-1)*'+FToSToRealToString(abs(Parametres[2])),StringAnalisis,p);
        end;
      end;
    end else HeDeFerBucle:=false;
  end;
  //C
  HeDeFerBucle:=true;
  while HeDeFerBucle do begin
    p:=Pos('C',StringAnalisis);
    if p<>0 then begin
      j:=Copy(StringAnalisis,p-2,1);
      k:=Copy(StringAnalisis,p-1,1);
      l:=Copy(StringAnalisis,p+1,1);
      m:=Copy(StringAnalisis,p+2,1);
      n:=Copy(StringAnalisis,p+3,1);
      if (l='O') then begin
        HeDeFerBucle:=false;
      end else if (l='G') then begin
        HeDeFerBucle:=false;
      end else begin
        Delete(StringAnalisis,p,1);
        if Parametres[3]>=0 then begin
          Insert(FToSToRealToString(Parametres[3]),StringAnalisis,p);
        end else begin
          Insert('(-1)*'+FToSToRealToString(abs(Parametres[3])),StringAnalisis,p);
        end;
      end;
    end else HeDeFerBucle:=false;
  end;
  //D
  HeDeFerBucle:=true;
  while HeDeFerBucle do begin
    p:=Pos('D',StringAnalisis);
    if p<>0 then begin
      Delete(StringAnalisis,p,1);
      if Parametres[4]>=0 then begin
        Insert(FToSToRealToString(Parametres[4]),StringAnalisis,p);
      end else begin
        Insert('(-1)*'+FToSToRealToString(abs(Parametres[4])),StringAnalisis,p);
      end;
    end else HeDeFerBucle:=false;
  end;
  //E
  HeDeFerBucle:=true;
  while HeDeFerBucle do begin
    p:=Pos('E',StringAnalisis);
    if p<>0 then begin
      j:=Copy(StringAnalisis,p-2,1);
      k:=Copy(StringAnalisis,p-1,1);
      l:=Copy(StringAnalisis,p+1,1);
      m:=Copy(StringAnalisis,p+2,1);
      n:=Copy(StringAnalisis,p+3,1);
      if (l='N') then begin
        HeDeFerBucle:=false;
      end else if (l='G') then begin
        HeDeFerBucle:=false;
      end else if (k='S') then begin
        HeDeFerBucle:=false;
      end else if (l='X') then begin
        HeDeFerBucle:=false;
      end else if (k='N') then begin
        HeDeFerBucle:=false;
      end else begin
        Delete(StringAnalisis,p,1);
        if Parametres[5]>=0 then begin
          Insert(FToSToRealToString(Parametres[5]),StringAnalisis,p);
        end else begin
          Insert('(-1)*'+FToSToRealToString(abs(Parametres[5])),StringAnalisis,p);
        end;
      end;
    end else HeDeFerBucle:=false;
  end;
  //F
  HeDeFerBucle:=true;
  while HeDeFerBucle do begin
    p:=Pos('F',StringAnalisis);
    if p<>0 then begin
      Delete(StringAnalisis,p,1);
      if Parametres[6]>=0 then begin
        Insert(FToSToRealToString(Parametres[6]),StringAnalisis,p);
      end else begin
        Insert('(-1)*'+FToSToRealToString(abs(Parametres[6])),StringAnalisis,p);
      end;
    end else HeDeFerBucle:=false;
  end;
end;

Procedure analitzar(StringAnalisis: String; var ErrorAnalisi,LlocErrorAnalisi: Integer);
label
  Bucle1, Marca1;

Procedure IniciAnal;
begin
  {texte}
  sen:='SIN(';
  gse:='SIG(';
  ase:='ASI(';
  Code:=0;
  l:=0; i:=0; n:=0; Nnp:=0; Cnp:=0; K:=0;
  ControlPunt:= 0;
  LeftaS:= '';
  iaS:= '';
  StringiS:= '';
  idS:= '';
  a1S:= '';
  Fallo:= 0;
  {ErrorAnalisi:= 0;}
  LLocErrorAnalisi:=1;
  c1S:= '';
  c2S:= '';
  c3S:= '';
  For i := 1 to Operacions do begin
    O[I] := 0;
    C[I] := '';
  end;
end;

Function LeftS(s: string; nombre: integer): string;
begin
  LeftS := Copy(s,1,nombre);
end;

Function RightS(s: string; nombre: integer): string;
begin
  RightS := Copy(s,Length(s)-nombre+1,nombre);
end;

Function CasMay(s: string): string;
var
  i,j: integer;
begin
  {14/09/97}
  {J := Ord(s[0]);}
  J:=length(s);
  For i := 1 to j Do s[i] := Upcase(s[i]);
  CasMay := s;
end;

Procedure Nous;
begin
  if i > 1 then begin
    n := n + 1;
    if i-1<20 then begin
      Val(Copy(StringAnalisis,1, i - 1),O[n],code);
      {C[n]:='N';}
      if Code<>0 then begin
        ErrorAnalisi := 10;
        Exit;
      end;
    end else begin
      ErrorAnalisi := 9;
      Exit;
    end;
  end;
  i := i + 2;
  n := n + 1;
  C[n] := LeftaS;
  StringAnalisis := RIGHTS(StringAnalisis, l - i);
  l := Length(StringAnalisis);
  i := 0;
end;

begin
  IniciAnal;
  StringAnalisis := CasMay(StringAnalisis);

  CanviarElsParametres(StringAnalisis);

  StringAnalisis := '('+StringAnalisis+')';
  {posat el 22/08/93 per si la funci no te gaires variables}
  l := Length(StringAnalisis);
  if (ErrorAnalisi<>102) then begin
    for i:=1 to l do begin
      if (Copy(StringAnalisis,i,1)='Y') or (Copy(StringAnalisis,i,1)='Z') or (Copy(StringAnalisis,i,1)='U') or (Copy(StringAnalisis,i,1)='V') then begin
        ErrorAnalisi := 2;
        Exit;
      end;
    end;
  end;
  ErrorAnalisi := 0;

  {Posat el 14/11/92 perqu hi hagi coses massa llargues}
  if l>Operacions+2 then begin
    ErrorAnalisi := 8;
    LlocErrorAnalisi:=1;
    exit;
  end;

  {Posat el 14/11/92 perqu entengui 2p y 2ne}
  i:=0;
  While i<l do begin
    l:=Length(StringAnalisis);
    i:=i+1;
    Ch1:=Copy(StringAnalisis,i,1); Ch2:=Copy(StringAnalisis,i+1,1);
    if (Ch1>='0') and (Ch1<='9') and ((Ch2='P') or (Ch2='N')) then begin
      Insert('*',StringAnalisis,i+1);
    {end else if (Ch1='X')  and ((Ch2='P') or (Ch2='N')  then begin
      Insert('*',StringAnalisis,i+1);}
    end;
  end;
  {Posat el 23/08/92 per que funcioni EXP, PI, ne}
  i:=0;
  l := Length(StringAnalisis);
  While i<l do begin
    l:=Length(StringAnalisis);
    i:=i+1;
    if Copy(StringAnalisis,i,4)='EXP(' then begin
      Delete(StringAnalisis,i,4);
      Insert('ALN(',StringAnalisis,i);
    end else if Copy(StringAnalisis,i,2)='PI' then begin
      Delete(StringAnalisis,i,2);
      Insert('3.141593',StringAnalisis,i);
    end else if Copy(StringAnalisis,i,1)='P' then begin
      Delete(StringAnalisis,i,1);
      Insert('3.141593',StringAnalisis,i);
    end else if Copy(StringAnalisis,i,2)='NE' then begin
      Delete(StringAnalisis,i,2);
      Insert('2.718282',StringAnalisis,i);
    {Posat el 29/10/92 perqu es pugui entrar espais}
    end else if Copy(StringAnalisis,i,1)=' ' then begin
      Delete(StringAnalisis,i,1);
      i:=i-1;
    {versi castellana del sinus 05/03/94}
    end else if Copy(StringAnalisis,i,4)='SEN(' then begin
      Delete(StringAnalisis,i,4);
      Insert('SIN(',StringAnalisis,i);
    end else if Copy(StringAnalisis,i,4)='ASE(' then begin
      Delete(StringAnalisis,i,4);
      Insert('ASI(',StringAnalisis,i);
    end else if Copy(StringAnalisis,i,4)='SEG(' then begin
      Delete(StringAnalisis,i,4);
      Insert('SIG(',StringAnalisis,i);
    end else if Copy(StringAnalisis,i,1)=',' then begin
      Delete(StringAnalisis,i,1);
      Insert('.',StringAnalisis,i);
    end else if Copy(StringAnalisis,i,1)='''' then begin
      Delete(StringAnalisis,i,1);
      Insert('.',StringAnalisis,i);
    end;
  end;
  {Posat el 28/10/92 perqu es pugui posar 5x per comptes de 5*x}
  i:=0;
  l := Length(StringAnalisis);
  While i<l do begin
    l:=Length(StringAnalisis);
    i:=i+1;
    Ch1:=Copy(StringAnalisis,i,1); Ch2:=Copy(StringAnalisis,i+1,1);
    if (Ch1>='0') and (Ch1<='9') and ((Ch2='(') or (Ch2='X')

     or (Ch2='Y') or (Ch2='Z') or (Ch2='U') or (Ch2='V')

     or (Ch2='S') or (Ch2='C') or (Ch2='T') or (Ch2='A')
     or (Ch2='L')) then begin
      Insert('*',StringAnalisis,i+1);
    end else if ((Ch1='X') or (Ch1='Y') or (Ch1='Z') or (Ch1='U') or (Ch1='V'))
     and ((Ch1='(')
     or (Ch2='S') or (Ch2='C') or (Ch2='T') or (Ch2='A')
     or (Ch2='L')) then begin
      Insert('*',StringAnalisis,i+1);
    end;
  end;
  {fins aqu}

  {posat el 29/10/92 per detectar que no hi ha res}
  if StringAnalisis='()' then begin
    ErrorAnalisi := 7;
    LlocErrorAnalisi:=1;
    exit;
  end;

  {Posat el 19/12/92 perqu hi hagi coses massa llargues}
  l := Length(StringAnalisis);
  if l=255 then begin
    ErrorAnalisi := 8;
    LlocErrorAnalisi:=1;
    exit;
  end;

  i:=0;
  l := Length(StringAnalisis);
  ControlPunt := 0;
  for i := 2 to l - 1 do begin
    iaS := Copy(StringAnalisis, i - 1, 1);
    StringiS := Copy(StringAnalisis, i, 1);
    idS := Copy(StringAnalisis, i + 1, 1);
    Fallo := 1;
    if ((iaS = '+') or (iaS = '-') or (iaS = '*') or (iaS = '/') or (iaS = '^')) and ((StringiS = '+')
      or (StringiS = '-') or (StringiS = '*') or (StringiS = '/') or (StringiS = '^') or (StringiS = ')')) then
    else if (iaS = '(') and ((StringiS = '*') or (StringiS = '/') or (StringiS = '^') or (StringiS = ')')) then
    else if ((iaS='X') or (iaS='Y') or (iaS='Z') or (iaS='U') or (iaS='V'))
     and (((StringiS='X') or (StringiS='Y') or (StringiS='Z') or (StringiS='U') or (StringiS='V')) or ((StringiS > '/') and (StringiS < ':')) or (StringiS = '.')) then
    else if (((iaS > '/') and (iaS < ':')) or (iaS = '.') or ((iaS='X') or (iaS='Y') or (iaS='Z') or (iaS='U') or (iaS='V')))
     and (((StringiS='X') or (StringiS='Y') or (StringiS='Z') or (StringiS='U') or (StringiS='V')) or (StringiS = '(') or
     (StringiS = 'S') or (StringiS = 'C') or (StringiS = 'T') or (StringiS = 'A') or (StringiS = 'L')) then
    else if (iaS = ')') and (((StringiS > '/') and (StringiS < ':')) or (StringiS = '.') or (StringiS = 'S')
      or (StringiS = 'C') or (StringiS = 'T') or (StringiS = 'A') or (StringiS = 'L') or
      ((StringiS='X') or (StringiS='Y') or (StringiS='Z') or (StringiS='U') or (StringiS='V'))) then
    else Fallo := 0;
    if StringiS = '.' then begin
      ControlPunt := ControlPunt + 1;
      if ((not((iaS > '/') and (iaS < ':'))) and (not((idS > '/') and (idS < ':')))) or (ControlPunt = 2)
        or (iaS = '.') then Fallo := 1;
    end
    else if (StringiS > '/') and (StringiS < ':') then
    else ControlPunt := 0;
    if Fallo = 1 then begin
      {Inicialment aix valia 7}
      ErrorAnalisi := 5;
      LlocErrorAnalisi:=1;
      exit;
    end;
  end;
  ErrorAnalisi := 0;
  a1S := StringAnalisis;
  l := length(StringAnalisis);
  n := 0;
  i := 1;
  Nnp := 0;
  Cnp := 0;
bucle1:
  StringiS := copy(StringAnalisis, i, 1);
  if ((StringiS > '''') and (StringiS < ',')) or ((StringiS > ',') and (StringiS < ':')) or ((StringiS='X') or (StringiS='Y') or (StringiS='Z') or (StringiS='U') or (StringiS='V'))
    or (StringiS = '^') or (StringiS = 'S') or (StringiS = 'C') or (StringiS = 'T') or (StringiS = 'A') or (StringiS = 'L') then
  begin
    if (StringiS = '(') or (StringiS = ')') or (StringiS = '+') or (StringiS = '-') or (StringiS = '*') or (StringiS = '/')
      or (StringiS = '^') then
    begin
      if StringiS = '(' then begin
        Cnp := Cnp + 1;
        if Cnp > Nnp then Nnp := Cnp;
      end else if StringiS = ')' then begin
        Cnp := Cnp - 1;
        if Cnp < 0 then begin
          ErrorAnalisi := 1;
          exit;
        end else if Cnp = 0 then begin
          if i < l - 1 then begin
            ErrorAnalisi := 1;
            Exit;
          end;
        end;
      end;
      if i > 1 then begin
        n := n + 1;
        if i-1<20 then begin
          VAL(LeftS(StringAnalisis, i - 1),O[n],code);
          {C[n]:='N';}
          if Code<>0 then begin
            ErrorAnalisi := 10;
            Exit;
          end;
        end else begin
          ErrorAnalisi := 9;
          Exit;
        end;
      end;
      n := n + 1;
      C[n] := StringiS;
      StringAnalisis := RightS(StringAnalisis, l - i);
      l := Length(StringAnalisis);
      i := 0;
    end
    else if ((StringiS > '''') and (StringiS < ',')) or ((StringiS > ',') and (StringiS < ':')) then
    else if (StringiS='X') or (StringiS='Y') or (StringiS='Z') or (StringiS='U') or (StringiS='V') then begin
      n := n + 1;
      C[n] := StringiS;
      StringAnalisis := RightS(StringAnalisis, l - i);
      l := Length(StringAnalisis);
      i := 0;
    end else if (StringiS = 'S') and (copy(StringAnalisis, i, 4) = sen) then begin
      LeftaS := 'SIN';
      Nous;
    end else if (StringiS = 'S') and (Copy(StringAnalisis, i, 4) = gse) then begin
      LeftaS := 'SIG';
      Nous;
    end else if (StringiS = 'A') and (Copy(StringAnalisis, i, 4) = ase) then begin
      LeftaS := 'ASI';
      Nous;
    end else if (StringiS = 'A') and (Copy(StringAnalisis, i, 4) = 'ASG(') then begin
      LeftaS := 'ASG';
      Nous;
    end else if (StringiS = 'C') and (Copy(StringAnalisis, i, 4) = 'COS(') then begin
      LeftaS := 'COS';
      Nous;
    end else if (StringiS = 'C') and (Copy(StringAnalisis, i, 4) = 'COG(') then begin
      LeftaS := 'COG';
      Nous;
    end else if (StringiS = 'A') and (Copy(StringAnalisis, i, 4) = 'ACO(') then begin
      LeftaS := 'ACO';
      Nous;
    end else if (StringiS = 'A') and (Copy(StringAnalisis, i, 4) = 'ACG(') then begin
      LeftaS := 'ACG';
      Nous;
    end else if (StringiS = 'T') and (Copy(StringAnalisis, i, 4) = 'TAN(') then begin
      LeftaS := 'TAN';
      Nous;
    end else if (StringiS = 'T') and (Copy(StringAnalisis, i, 4) = 'TAG(') then begin
      LeftaS := 'TAG';
      Nous;
    end else if (StringiS = 'A') and (Copy(StringAnalisis, i, 4) = 'ATA(') then begin
      LeftaS := 'ATA';
      Nous;
    end else if (StringiS = 'A') and (Copy(StringAnalisis, i, 4) = 'ATG(') then begin
      LeftaS := 'ATG';
      Nous;
    end else if (StringiS = 'A') and (Copy(StringAnalisis, i, 4) = 'ABS(') then begin
      LeftaS := 'ABS';
      Nous;
    end else if (StringiS = 'L') and (Copy(StringAnalisis, i, 4) = 'LOG(') then begin
      LeftaS := 'LOG';
      Nous;
    end else if (StringiS = 'A') and (Copy(StringAnalisis, i, 4) = 'ALO(') then begin
      LeftaS := 'ALO';
      Nous;
    end else if (StringiS = 'A') and (Copy(StringAnalisis, i, 4) = 'ALN(') then begin
      LeftaS := 'EXP';
      Nous;
    end else if (StringiS = 'L') and (Copy(StringAnalisis, i, 3) = 'LN(') then begin
      if i > 1 then begin
        n := n + 1;
        if i-1<20 then begin
          VAL(LeftS(StringAnalisis, i - 1),O[n],code);
          {C[n]:='N';}
          if Code<>0 then begin
            ErrorAnalisi := 10;
            Exit;
          end;
        end else begin
          ErrorAnalisi := 9;
          Exit;
        end;
      end;
      i := i + 1;
      n := n + 1;
      C[n] := 'LNE';
      StringAnalisis := RightS(StringAnalisis, l - i);
      l := Length(StringAnalisis);
      i := 0;
    end else begin
      ErrorAnalisi := 2;
      Exit;
    end;
  end else begin
    ErrorAnalisi := 3;
    Exit;
  end;
  if ErrorAnalisi<>0 then exit;
marca1:
  i := i + 1;
  if i <= l then GOTO bucle1;
  if Cnp <> 0 then begin
    ErrorAnalisi := 4;
    Exit;
  end;
  i:=1;
  while i<=n do begin
  {For i := 1 To n do begin}
    c1S := C[i];
    c2S := C[i + 1];
    c3S := C[i - 1];
    if (((c1S = '+') or (c1S = '-') or (c1S = '*') or (c1S = '/') or (c1S = '^'))
      and ((c2S = ')') or (c2S = '+') or (c2S = '-') or (c2S = '*') or (c2S = '/')))
      or ((c1S = '(') and ((c2S = '*') or (c2S = '/') or (c2S = ')') or (c3S = ')')))
      or ((c1S = ')') and ((c2S = 'S') or  (c2S = 'C') or (c2S = 'T') or (c2S = 'A')
      or (c2S = 'L'))) then
    begin
      ErrorAnalisi := 5;
      Exit;
    end;
    if c1S = '(' then begin
     if c2S = '+' then begin
       For K := i + 1 To n - 1 do begin
         O[K] := O[K + 1];
         C[K] := C[K + 1];
       end;
       C[n] := '';
       n := n - 1;
        {No ho accepta DELPHI 3 en un FOR}
       i := i - 1;
     end else if c2S = '-' then begin
       For K := n Downto i do begin
         O[K + 1] := O[K];
         C[K + 1] := C[K];
       end;
       n := n + 1;
       C[i + 1] := '';
       O[i + 1] := -1;
       C[i + 2] := '*';
     end;
    end;
    inc(i);
  end;
End;

Procedure IniciCal;
var
  Iii: Integer;
begin
  For Iii := 1 to Operacions do begin
    O2[Iii] := 0;
    C2[Iii] := '';
  end;
end;

Procedure CalcularCoses(var ycReal: Real; var ErrorCalcul: Integer);
var
  nf,Ii,j,j2: Integer;
  n2,nnp2: Integer;

label
  Bucle4, Fora1, Final;

Procedure Reordena;
begin
  for K := i to n2 do begin
    O2[K] := O2[K + 2];
    C2[K] := C2[K + 2];
  end;
  nf := nf - 2;
  n2 := n2 - 2;
  i := i - 1;
end;

Procedure Reordena2;
begin
  C2[Ii - 1] := '';
  for K := Ii to n2 do begin
    O2[K] := O2[K + 1];
    C2[K] := C2[K + 1];
  end;
  nf := nf - 1;
  n2 := n2 - 1;
end;

function Potencia(x,y:real):real;
var
  r: real;
  Argument: Real;
  n: integer;

  k: integer;
  P:real;

begin
  {canviat el 07/04/93 a causa de que les potncies enteres no les calculava exactament}
  {canviat el 12/12/93 y<100 per abs(y)<100}
  if (y=int(y)) and (y<>0) and (abs(y)<100) then begin
    k:=abs(trunc(y));
    P:=1;
    for n:=1 to k do begin
      if (P>1.0E+19) or (x>1.0E+19) then begin
        ErrorCalcul := 4;
        Exit;
      end;
       P:=P*x;
    end;
    if (y<0) then begin
      if (P>1.0E-19) then begin
        Potencia:=1/P;
      end else begin
        ErrorCalcul := 4;
        Exit;
      end;
    end else begin
      Potencia:=P;
    end;
  end else

   if x > 0 then begin
    r := y * ln(x);
    if (r > -88) and (r < 88) then begin
      Potencia := exp(r);
    end else begin
      ErrorCalcul := 4; {Overflow}
    end;
  end else if x = 0 then begin
    if y>0 then Potencia := 0 else Errorcalcul:=2;{0 elevat a 0, o a nombre negatiu}
  end else begin
    ErrorCalcul := 2;      {potncia base negativa}
    n := 0;
    Repeat
      Argument := pi * y + 2 * pi * n * y;
      if (sin(Argument) < 0.00001) and (sin(Argument) > -0.00001)then begin
        ErrorCalcul := 0;
        r := y * ln(abs(x));
        if (r > -88) and (r < 88) then begin
          Potencia := exp(r) * cos(Argument);
        end else begin
          ErrorCalcul := 4; {Overflow}
        end;
      end;
      inc(n);
    until (abs(Argument) > 2 * pi) or (ErrorCalcul = 0);
  end;
end;

function Tan(x:real):real;
begin
  if  (abs(cos(x))>1.0E-19) then begin
    Tan := sin(x)/cos(x);
  end else begin
    ErrorCalcul := 4; {Overflow}
    Exit;
  end;
end;

function ArrelQuadrada(x:real):real;
begin
  if  (x>=0) then begin
    ArrelQuadrada:=Sqrt(x);
  end else begin
    ErrorCalcul := 2; {Arrel negativa}
    Exit;
  end;
end;

Procedure Calculs;
label
  Bucle21, Bucle2, Bucle3;
begin
  i := Ii;
Bucle21:
  i := i + 1;
  if C2[i] = '^' then begin
    O2[i - 1] := Potencia(O2[i - 1], O2[i + 1]);
    if ErrorCalcul <> 0 then Exit;
    Reordena;
  end;
  if i < nf - 1 then GOTO Bucle21;
  i := Ii;
Bucle2:
  i := i + 1;
  if C2[i] = '*' then begin
    if  (abs(O2[i - 1])<1.0E+19) and (abs(O2[i + 1])<1.0E+19) then begin
      O2[i - 1] := O2[i - 1] * O2[i + 1];
      Reordena;
    end else begin
      ErrorCalcul := 4; {Overflow}
      Exit;
    end;
  end else if C2[i] = '/' then begin
    if O2[i +1] <> 0 then begin
      if  (abs(O2[i - 1])<1.0E+19) and (abs(O2[i + 1])>1.0E-19) then begin
        O2[i - 1] := O2[i - 1] / O2[i + 1];
        Reordena;
      end else begin
        ErrorCalcul := 4; {Overflow}
        Exit;
      end;
    end else begin
      ErrorCalcul := 1; {Divisi per 0}
      Exit;
    end;
  end;
  if i < nf - 1 then GOTO Bucle2;
  i := Ii;
Bucle3:
  i := i + 1;
  if C2[i] = '+' then begin
    if  (abs(O2[i - 1])<1.0E+19) and (abs(O2[i + 1])<1.0E+19) then begin
      O2[i - 1] := O2[i - 1] + O2[i + 1];
      Reordena;
    end else begin
      ErrorCalcul := 4; {Overflow}
      Exit;
    end;
  end else if C2[i] = '-' then begin
    if  (abs(O2[i - 1])<1.0E+19) and (abs(O2[i + 1])<1.0E+19) then begin
      O2[i - 1] := O2[i - 1] - O2[i + 1];
      Reordena;
    end else begin
      ErrorCalcul := 4; {Overflow}
      Exit;
    end;
  end;
  if i < nf - 1 then GOTO Bucle3;
  O2[Ii] := O2[Ii + 1];
  C2[Ii] := '';
  C2[Ii + 2] := '';
  i := Ii + 1;
  Reordena;
  if C2[Ii - 1] = 'SIN' then begin
    O2[Ii - 1] := SIN(O2[Ii]);
    Reordena2;
  end else if C2[Ii - 1] = 'SIG' then begin
    O2[Ii - 1] := SIN(O2[Ii] / 180 * 3.141593);
    Reordena2;
  end else if C2[Ii - 1] = 'ASI' then begin
    if O2[Ii] = 1 then begin
      O2[Ii - 1] := 1.570796;
    end else if O2[Ii] = -1 then begin
      O2[Ii - 1] := -1.570796;
    end else begin
      O2[Ii - 1] :=ArrelQuadrada(1-Sqr(O2[Ii]));
      if ErrorCalcul <> 0 then Exit;
      O2[Ii - 1] := Arctan(O2[Ii]/O2[Ii - 1]);
      if ErrorCalcul <> 0 then Exit;
    end;
    Reordena2;
  end else if C2[Ii - 1] = 'ASG' then begin
    if O2[Ii] = 1 then begin
      O2[Ii - 1] := 90;
    end else if O2[Ii] = -1 then begin
      O2[Ii - 1] := -90;
    end else begin
      O2[Ii - 1] :=ArrelQuadrada(1-Sqr(O2[Ii]));
      if ErrorCalcul <> 0 then Exit;
      O2[Ii - 1] := Arctan(O2[Ii]/O2[Ii - 1])*180/3.141593;
      if ErrorCalcul <> 0 then Exit;
    end;
    Reordena2;
  end else if C2[Ii - 1] = 'COS' then begin
    O2[Ii - 1] := Cos(O2[Ii]);
    Reordena2;
  end else if C2[Ii - 1] = 'COG' then begin
    O2[Ii - 1] := Cos(O2[Ii] / 180 * 3.141593);
    Reordena2;
  end else if C2[Ii - 1] = 'ACO' then begin
    if O2[Ii] = 0 then begin
      O2[Ii - 1] := 1.570796;
    end else if O2[Ii] < 0 then begin
      O2[Ii - 1] :=ArrelQuadrada(1 - Sqr(O2[Ii]));
      if ErrorCalcul <> 0 then Exit;
      O2[Ii - 1] := Arctan( O2[Ii - 1]/ O2[Ii]) + 3.141593;
    end else begin
      O2[Ii - 1] :=ArrelQuadrada(1 - Sqr(O2[Ii]));
      if ErrorCalcul <> 0 then Exit;
      O2[Ii - 1] := Arctan( O2[Ii - 1] / O2[Ii]);
    end;
    if ErrorCalcul <> 0 then Exit;
    Reordena2;
  end else if C2[Ii - 1] = 'ACG' then begin
    if O2[Ii] = 0 then begin
      O2[Ii - 1] := 90;
    end else if O2[Ii] < 0 then begin
      O2[Ii - 1] :=ArrelQuadrada(1 - Sqr(O2[Ii]));
      if ErrorCalcul <> 0 then Exit;
      O2[Ii - 1] := Arctan(O2[Ii - 1] / O2[Ii]) * 180 / 3.141593 + 180;
    end else begin
      O2[Ii - 1] :=ArrelQuadrada(1 - Sqr(O2[Ii]));
      if ErrorCalcul <> 0 then Exit;
      O2[Ii - 1] := Arctan(O2[Ii - 1] / O2[Ii]) * 180 / 3.141593;
    end;
    if ErrorCalcul <> 0 then Exit;
    Reordena2;
  end else if C2[Ii - 1] = 'TAN' then begin
    O2[Ii - 1] := Tan(O2[Ii]);
    if ErrorCalcul <> 0 then Exit;
    Reordena2;
  end else if C2[Ii - 1] = 'TAG' then begin
    O2[Ii - 1] := Tan(O2[Ii] / 180 * 3.141593);
    if ErrorCalcul <> 0 then Exit;
    Reordena2;
  end else if C2[Ii - 1] = 'ATA' then begin
    O2[Ii - 1] := Arctan(O2[Ii]);
    if ErrorCalcul <> 0 then Exit;
    Reordena2;
  end else if C2[Ii - 1] = 'ATG' then begin
    O2[Ii - 1] := Arctan(O2[Ii]) * 180 / 3.141593;
    if ErrorCalcul <> 0 then Exit;
    Reordena2;
  end else if C2[Ii - 1] = 'ABS' then begin
    O2[Ii - 1] := ABS(O2[Ii]);
    Reordena2;
  end else if C2[Ii - 1] = 'LNE' then begin
    if O2[Ii] > 0 then begin
      O2[Ii - 1] := Ln(O2[Ii]);
      Reordena2;
    end else begin
      ErrorCalcul := 3; {logarime d'un nombre negatiu}
      Exit;
    end;
  end else if C2[Ii - 1] = 'LOG' then begin
    if O2[Ii] > 0 then begin
      O2[Ii - 1] := Ln(O2[Ii]) / Ln(10);
      Reordena2;
    end else begin
      ErrorCalcul := 3; {logarime d'un nombre negatiu}
      Exit;
    end;
  end else if C2[Ii - 1] = 'ALO' then begin
    O2[Ii - 1] := Potencia(10, O2[Ii]);
    {if ErrorCalcul = 4 then Exit;}
    if ErrorCalcul <> 0 then Exit;
    Reordena2;
  end else if C2[Ii - 1] = 'EXP' then begin
    if (O2[Ii] > -88) and (O2[Ii] < 88)then begin
      O2[Ii - 1] := Exp(O2[Ii]);
      if ErrorCalcul <> 0 then Exit;
      Reordena2;
    end else begin
      ErrorCalcul := 4; {Overflow}
      Exit;
    end;
  end;
end;


function CercarParentesiInterior(var pi,pf:integer):boolean;
var
  i:integer;
begin
  pi:=0;pf:=0;
  CercarParentesiInterior:=false;
  for i:=1 to n2 do begin
    if C2[i]='(' then pi:=i;
    if C2[i]=')' then begin
      pf:=i;
      {i:=n2;}
      Break;
    end;
  end;
  if (pi<>0) and (pf<>0) then CercarParentesiInterior:=true;
end;

begin
  nf:=0; Ii:=0; j:=0; j2:=0;
  n2 := n;
  nnp2 := Nnp;
  Cnp := 0;
Bucle4:
  {For j := 1 to n2 do begin
    if C2[j] = '(' then begin
      Cnp := Cnp + 1;
      if nnp2 = Cnp then begin
        Ii := j;
        For J2 := j to n2 do begin
          if C2[J2] = ')' then goto Fora1;
        end;
Fora1:
        nf := J2;
        Calculs;
        if ErrorCalcul <> 0 then goto Final;
        Cnp := Cnp - 1;
      end;
    end else if C2[j] = ')' then begin
      Cnp := Cnp - 1;
    end;
  end;}
{ no es necessari, pero per mes bona asseguransa}
  {Cnp := 0;
  nnp2 := nnp2 - 1;
  if nnp2 > 0 then GOTO Bucle4;}

  while CercarParentesiInterior(Ii,nf) do begin
    Calculs;
    if ErrorCalcul <> 0 then goto Final;
  end;
  ycReal := O2[1];
  if  (abs(ycReal)> 1.0E+19) then ErrorCalcul := 4; {Overflow}
Final:
{Afegit el 16/09/92 sembla que tenia ms importncia}
{ no es necessari, pero per mes bona asseguransa}
  {Cnp := 0;}
end;

{Procedure CalcularXYZUV (var x1,y1,z1,u1,v1: Real; var ycReal: Real; var ErrorCalcul: Integer);}
Procedure CalcularXYZUV (x1,y1,z1,u1,v1: Real; var ycReal: Real; var ErrorCalcul: Integer);
var
  j: integer;
begin
  IniciCal;
  ErrorCalcul:= 0;
  For j := 1 to n do begin
    if C[j] = 'X' then begin
      C2[j] := '';
      O2[j] := x1;
    end else if C[j] = 'Y' then begin
      C2[j] := '';
      O2[j] := y1;
    end else if C[j] = 'Z' then begin
      C2[j] := '';
      O2[j] := z1;
    end else if C[j] = 'U' then begin
      C2[j] := '';
      O2[j] := u1;
    end else if C[j] = 'V' then begin
      C2[j] := '';
      O2[j] := v1;
    end else begin
      C2[j] := C[j];
      O2[j] := O[j];
    end;
  end;
  CalcularCoses(ycReal,ErrorCalcul);
end;

Procedure Calcular(var xcReal: Real; var ycReal: Real; var ErrorCalcul: Integer);
var
  j: integer;
begin
  IniciCal;
  ErrorCalcul:= 0;
  For j := 1 to n do begin
    if C[j] = 'X' then begin
      C2[j] := '';
      O2[j] := xcReal;
    end else if C[j] = 'Y' then begin
      C2[j] := '';
      O2[j] := 0;
    end else if C[j] = 'Z' then begin
      C2[j] := '';
      O2[j] := 0;
    end else if C[j] = 'U' then begin
      C2[j] := '';
      O2[j] := 0;
    end else if C[j] = 'V' then begin
      C2[j] := '';
      O2[j] := 0;
    end else begin
      C2[j] := C[j];
      O2[j] := O[j];
    end;
  end;
  CalcularCoses(ycReal,ErrorCalcul);
end;

Procedure DonarOperacions(var O3: OReal; var C3: CString; var NumeroOperacions: integer);
var
  i:integer;
begin
  For i := 1 to Operacions do begin
    O3[i]:=0;
    C3[i]:='';
  end;
  NumeroOperacions:=n;
  For i := 1 to n do begin
    O3[i]:=O[i];
    C3[i]:=C[i];
    if C3[i]='' then C3[i]:= 'N';
  end;
end;

Procedure DonarDades(var O3: OReal; var C3: CString; var NumeroOperacions: integer);
var
  i:integer;
begin
  NumeroOperacions:=n;
  For i := 1 to n do begin
    O3[i]:=O[i];
    C3[i]:=C[i];
    if C3[i]='' then C3[i]:= 'N';
  end;
  if (C3[1]='(') and (C3[2]='N') and (C3[3]='*') and (C3[4]='N') then begin
    O3[2]:=O3[2]*O3[4];
    NumeroOperacions:=NumeroOperacions-2;
    for i:=3 to NumeroOperacions do begin
      O3[i]:=O3[i+2];
      C3[i]:=C3[i+2];
    end;
  end;
  if (C3[1]='(') and ((C3[2]='X') or (C3[2]='Y') or (C3[2]='Z') or (C3[2]='U') or (C3[2]='V'))
   and (NumeroOperacions+2<Operacions) then begin
    NumeroOperacions:=NumeroOperacions+2;
    for i:=NumeroOperacions downto 4  do begin
      O3[i]:=O3[i-2];
      C3[i]:=C3[i-2];
    end;
    O3[2]:=1;
    C3[2]:='N';
    C3[3]:='*';
  end;
  i:=1;
  while i<NumeroOperacions do begin
    if (C3[i]='-') and (C3[i+1]='N') then begin
      O3[i+1]:=-O3[i+1];
      C3[i]:='+';
    end;
    if ((C3[i]='-') or (C3[i]='+')) and
     ((C3[i+1]='X') or (C3[i+1]='Y') or (C3[i+1]='Z') or (C3[i+1]='U') or (C3[i+1]='V'))
     and (NumeroOperacions+2<Operacions) then begin
      NumeroOperacions:=NumeroOperacions+2;
      for n:=NumeroOperacions downto i+3  do begin
        O3[n]:=O3[n-2];
        C3[n]:=C3[n-2];
      end;
      if C3[i]='-' then O3[i+1]:=-1 else O3[i+1]:=1;
      C3[i]:='+';
      C3[i+1]:='N';
      C3[i+2]:='*';
    end;
    i:=i+1;
  end;
end;
{
Function Arrodonir(V:Real):Longint;
begin
  if v>2000000000 then begin
    Arrodonir:=2000000000;
  end else if v<-2000000000 then begin
    Arrodonir:=-2000000000;
  end else begin
    Arrodonir:=Round(v);
  end;
end;

Function RealToString(V:Real):String;
var
  s:string;
  d,i,n:integer;
begin
  if v>100000 then v:=int(v);
  if V=Arrodonir(V) then begin
    Str(V:1:0,s);
    RealToString:= s;
  end else begin
    Str(V:1:6,s);
    d:=length(s);
    for i:=d downto d-6 do begin
      if Copy(s,i,1)<>'0' then begin
        n:=i;
        //i:=d-6;
        Break;
      end;
      if Copy(s,n,1)='.' then n:=n-1;
      RealToString:=Copy(s,1,n);
    end;
  end;
end;
}
{function CalcularExpressio(StringExpressio:string):string; }
function CalcularExpressio(StringExpressio:string):ShortString;
var
  StringComodi1,StringComodi2:string;
  ErrorAnalisi,LlocErrorAnalisi,ErrorCalcul:integer;
  x,yc:real;
begin
  StringComodi2:=StringExpressio;
  ErrorAnalisi := 0;
  LlocErrorAnalisi:=0;
  analitzar(StringComodi2,ErrorAnalisi,LlocErrorAnalisi);
  if ErrorAnalisi = 0 then begin
    x:=0;
    ErrorCalcul := 0;
    yc:=0;
    Calcular(x,yc,ErrorCalcul);
    if ErrorCalcul = 0 then begin
      //str(yc,StringComodi1);
      StringComodi1:=RealToString(yc);
      StringComodi2 := StringComodi2 + ' = '+ StringComodi1;
    end else begin
      StringComodi2:= StringComodi2 + ' = '+ 'ERROR DE CLCUL';
    end;
  end else begin
    StringComodi2:= StringComodi2 + ' = '+ 'ERROR D''ANLISIS';
  end;
  CalcularExpressio:=StringComodi2;
end;

function CalcularExpressioResultat(StringExpressio:string):ShortString;
var
  StringComodi1,StringComodi2:string;
  ErrorAnalisi,LlocErrorAnalisi,ErrorCalcul:integer;
  x,yc:real;
begin
  StringComodi2:=StringExpressio;
  ErrorAnalisi := 0;
  LlocErrorAnalisi:=0;
  analitzar(StringComodi2,ErrorAnalisi,LlocErrorAnalisi);
  if ErrorAnalisi = 0 then begin
    x:=0;
    ErrorCalcul := 0;
    yc:=0;
    Calcular(x,yc,ErrorCalcul);
    if ErrorCalcul = 0 then begin
      //str(yc,StringComodi1);
      StringComodi2:=RealToString(yc);
      //StringComodi2 := StringComodi2 + ' = '+ StringComodi1;
    end else begin
      StringComodi2:= StringComodi2 + ' = '+ 'ERROR DE CLCUL';
    end;
  end else begin
    StringComodi2:= StringComodi2 + ' = '+ 'ERROR D''ANLISIS';
  end;
  CalcularExpressioResultat:=StringComodi2;
end;

{Procedure ProcCalcularExpressio(var StringExpressio:string);}
Procedure ProcCalcularExpressio(var StringExpressio:ShortString);
var
  ErrorAnalisi,LlocErrorAnalisi,ErrorCalcul:integer;
  x,yc:real;
  StringComodi1,StringComodi2:string;
begin
  StringComodi2:=StringExpressio;
  ErrorAnalisi := 0;
  LlocErrorAnalisi:=0;
  analitzar(StringComodi2,ErrorAnalisi,LlocErrorAnalisi);
  if ErrorAnalisi = 0 then begin
    x:=0;
    ErrorCalcul := 0;
    yc:=0;
    Calcular(x,yc,ErrorCalcul);
    if ErrorCalcul = 0 then begin
      str(yc,StringComodi1);
      StringComodi2 := StringComodi2 + ' = '+ StringComodi1;
    end else begin
      StringComodi2:= StringComodi2 + ' = '+ 'ERROR DE CLCUL';
    end;
  end else begin
    StringComodi2:= StringComodi2 + ' = '+ 'ERROR D''ANLISIS';
  end;
  StringExpressio:=StringComodi2;
end;

function CalcularCurrency(StringExpressio:string; var NumeroError:integer):single;
var
  StringComodi:string;
  ErrorAnalisi,LlocErrorAnalisi,ErrorCalcul:integer;
  x,yc:real;
begin
  StringComodi:=StringExpressio;
  ErrorAnalisi := 0;
  LlocErrorAnalisi:=0;
  analitzar(StringComodi,ErrorAnalisi,LlocErrorAnalisi);
  if ErrorAnalisi = 0 then begin
    x:=0;
    ErrorCalcul := 0;
    yc:=0;
    Calcular(x,yc,ErrorCalcul);
    if ErrorCalcul = 0 then begin
      CalcularCurrency:=yc;
      NumeroError:=0;
    end else begin
      NumeroError:=1;
    end;
  end else begin
    NumeroError:=2;
  end;
end;

begin
 for i:=1 to NombreMaximDeParametres do Parametres[i]:=1;
end.
