{*
 * Projecte Fressa a LINKAT
 * FUNCIONS WIN 32
 *
 * Author Jordi Lagares Roset "jlagares@xtec.cat - www.lagares.org"
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (see the LICENSE file).
 *}

unit UnitFindAWindow;

{*******************************************************}
interface
{*******************************************************}

uses Windows, SysUtils, Messages;

function FindAWindow(s:string;ClassName:string):THandle;
Procedure CrearTransparencia(i:integer;c:string);

{*******************************************************}
implementation
{*******************************************************}

uses Graphics;

const
  LWA_COLORKEY = 1;
  LWA_ALPHA     = 2;
  WS_EX_LAYERED = $80000;

function SetLayeredWindowAttributes(Wnd: hwnd;crKey: ColorRef;Alpha: Byte;dwFlags: DWORD): Boolean; stdcall; external 'user32.dll';

{*******************************************************}
type
 PFindWindowStruct = ^TFindWindowStruct;
 TFindWindowStruct = record
   Caption : string;
   ClassName : string;
   WindowHandle : THandle;
 end;

function EnumWindowsProc(hWindow : hWnd;lParam  : LongInt) : Bool{$IFDEF Win32} stdcall; {$ELSE} ; export; {$ENDIF}
var
 lpBuffer : PChar;
 WindowCaptionFound : bool;
 ClassNameFound : bool;

begin
 GetMem(lpBuffer, 255);
 Result := True;
 WindowCaptionFound := False;
 ClassNameFound := False;

 try
   if GetWindowText(hWindow, lpBuffer, 255) > 0 then
     if Pos(PFindWindowStruct(lParam).Caption, StrPas(lpBuffer)) > 0
      then WindowCaptionFound := true;

   if PFindWindowStruct(lParam).ClassName = '' then
     ClassNameFound := True else
       if GetClassName(hWindow, lpBuffer, 255) > 0 then
         if Pos(PFindWindowStruct(lParam).ClassName, StrPas(lpBuffer))
          > 0 then ClassNameFound := True;

   if (WindowCaptionFound and ClassNameFound) then begin
     PFindWindowStruct(lParam).WindowHandle := hWindow;
     Result := False;
   end;

 finally
   FreeMem(lpBuffer, sizeof(lpBuffer^));
 end;
end;

function FindAWindow(s : string;ClassName : string) : THandle;
var
 WindowInfo : TFindWindowStruct;
begin
 with WindowInfo do begin
   Caption := s;
   ClassName := ClassName;
   WindowHandle := 0;
   EnumWindows(@EnumWindowsProc, LongInt(@WindowInfo));
   FindAWindow := WindowHandle;
 end;
end;

{*******************************************************}
Procedure CrearTransparencia(i:integer;C:string);
var
  dwLong:DWORD;
  Info: TOSVersionInfo;
  AppInstFuncions:HWnd;
begin
  Info.dwOSVersionInfoSize:=SizeOf(Info);
  GetVersionEx(Info);
  if not ((Info.dwPlatformId=VER_PLATFORM_WIN32_NT) and (Info.dwMajorVersion>=5)) then exit;
  AppInstFuncions:=FindAWindow(c,'');
  if i=1 then begin
    SetWindowLong(AppInstFuncions, GWL_EXSTYLE, GetWindowLong(AppInstFuncions, GWL_EXSTYLE) or WS_EX_LAYERED);
    SetLayeredWindowAttributes(AppInstFuncions, ColorToRGB(clWhite), 255, LWA_COLORKEY);
  end else begin
    dwLong := GetWindowLong(AppInstFuncions, GWL_EXSTYLE);
    SetWindowLong(AppInstFuncions, GWL_EXSTYLE, dwLong and (NOT WS_EX_LAYERED));
  end;
end;

{
 procedure TForm1.Button1Click(Sender: TObject);
 var
   TheWindowHandle : THandle;
 begin
   TheWindowHandle := FindAWindow('Microsoft Word - ', '');
   if TheWindowHandle = 0 then
     ShowMessage('Window Not Found!') else
     BringWindowToTop(TheWindowHandle);
 end;
}
end.
