{*
 * Projecte Fressa a LINKAT
 * FUNCIONS WIN 32
 *
 * Author Jordi Lagares Roset "jlagares@xtec.cat - www.lagares.org"
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (see the LICENSE file).
 *}

unit UnitFormCanviDeParametres;

{*******************************************************************************}
interface
{*******************************************************************************}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls;

type
  TFormCanviDeParametres = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    EditA: TEdit;
    Label2: TLabel;
    EditB: TEdit;
    EditIncrement: TEdit;
    Label3: TLabel;
    UpDownA: TUpDown;
    UpDownB: TUpDown;
    Label4: TLabel;
    EditC: TEdit;
    UpDownC: TUpDown;
    Label5: TLabel;
    EditD: TEdit;
    UpDownD: TUpDown;
    Label6: TLabel;
    EditE: TEdit;
    UpDownE: TUpDown;
    Label7: TLabel;
    EditF: TEdit;
    UpDownF: TUpDown;
    procedure EditAKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure UpDownAClick(Sender: TObject; Button: TUDBtnType);
    procedure EditAChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormCanviDeParametres: TFormCanviDeParametres;

{*******************************************************************************}
implementation
{*******************************************************************************}

uses UnitCalcular, UnitFormPrincipal, Unitvariables, UnitTools;

{$R *.DFM}

var
  x,y:Real;
  Errors:integer;
  u:integer;
  s:string;

procedure TFormCanviDeParametres.EditAKeyDown(Sender: TObject;var Key: Word; Shift: TShiftState);
begin
  if (Key=40) or (Key=38) then begin
    x:=CalcularCurrency(EditIncrement.Text,Errors);
    if Errors=0 then begin
      if Sender=EditA then begin
        s:=EditA.Text;
      end else if Sender=EditB then begin
        s:=EditB.Text;
      end else if Sender=EditC then begin
        s:=EditC.Text;
      end else if Sender=EditD then begin
        s:=EditD.Text;
      end else if Sender=EditE then begin
        s:=EditE.Text;
      end else if Sender=EditF then begin
        s:=EditF.Text;
      end;
      y:=CalcularCurrency(s,Errors);
      if Errors=0 then begin
        if Key=40 then u:=-1 else u:=1;
        if Sender=EditA then begin
          EditA.Text:=FToSToRealToString(y+u*x);
        end else if Sender=EditB then begin
          EditB.Text:=FToSToRealToString(y+u*x);
        end else if Sender=EditC then begin
          EditC.Text:=FToSToRealToString(y+u*x);
        end else if Sender=EditD then begin
          EditD.Text:=FToSToRealToString(y+u*x);
        end else if Sender=EditE then begin
          EditE.Text:=FToSToRealToString(y+u*x);
        end else if Sender=EditF then begin
          EditF.Text:=FToSToRealToString(y+u*x);
        end;
      end;
    end;
  end;
end;

procedure TFormCanviDeParametres.UpDownAClick(Sender: TObject;Button: TUDBtnType);
begin
  x:=CalcularCurrency(EditIncrement.Text,Errors);
  if Errors=0 then begin
    if Sender=UpDownA then begin
      y:=CalcularCurrency(EditA.Text,Errors);
    end else if Sender=UpDownB then begin
      y:=CalcularCurrency(EditB.Text,Errors);
    end else if Sender=UpDownC then begin
      y:=CalcularCurrency(EditC.Text,Errors);
    end else if Sender=UpDownD then begin
      y:=CalcularCurrency(EditD.Text,Errors);
    end else if Sender=UpDownE then begin
      y:=CalcularCurrency(EditE.Text,Errors);
    end else if Sender=UpDownF then begin
      y:=CalcularCurrency(EditF.Text,Errors);
    end;
    if Errors=0 then begin
      if Button=btPrev then u:=-1 else u:=1;
      if Sender=UpDownA then begin
        EditA.Text:=FToSToRealToString(y+u*x);
      end else if Sender=UpDownB then begin
        EditB.Text:=FToSToRealToString(y+u*x);
      end else if Sender=UpDownC then begin
        EditC.Text:=FToSToRealToString(y+u*x);
      end else if Sender=UpDownD then begin
        EditD.Text:=FToSToRealToString(y+u*x);
      end else if Sender=UpDownE then begin
        EditE.Text:=FToSToRealToString(y+u*x);
      end else if Sender=UpDownF then begin
        EditF.Text:=FToSToRealToString(y+u*x);
      end;
    end;
  end;
end;

procedure TFormCanviDeParametres.EditAChange(Sender: TObject);
var
  s:string;
begin
  if Sender=EditA then begin
    x:=CalcularCurrency(EditA.Text,Errors);
  end else if Sender=EditB then begin
    x:=CalcularCurrency(EditB.Text,Errors);
  end else if Sender=EditC then begin
    x:=CalcularCurrency(EditC.Text,Errors);
  end else if Sender=EditD then begin
    x:=CalcularCurrency(EditD.Text,Errors);
  end else if Sender=EditE then begin
    x:=CalcularCurrency(EditE.Text,Errors);
  end else if Sender=EditF then begin
    x:=CalcularCurrency(EditF.Text,Errors);
  end;
  if Errors=0 then begin
    if Sender=EditA then begin
      Parametres[1]:=x;
    end else if Sender=EditB then begin
      Parametres[2]:=x;
    end else if Sender=EditC then begin
      Parametres[3]:=x;
    end else if Sender=EditD then begin
      Parametres[4]:=x;
    end else if Sender=EditE then begin
      Parametres[5]:=x;
    end else if Sender=EditF then begin
      Parametres[6]:=x;
    end;
    FormPrincipal.MenuCanviarFuncionsOParametresDAcord;
    if NumeroDeFuncions=1 then begin
      s:=CasMay(PrimeraFuncio);
      CanviarElsParametres(s);
      Caption:=missatges[250]+' - f(x) = '+s;
    end;
  end;
end;

procedure TFormCanviDeParametres.FormActivate(Sender: TObject);
begin
  if NumeroDeFuncions=1 then begin
    s:=CasMay(PrimeraFuncio);
    CanviarElsParametres(s);
    Caption:=missatges[250]+' - f(x) = '+s;
  end;
end;

end.
