{*
 * Projecte Fressa a LINKAT
 * FUNCIONS WIN 32
 *
 * Author Jordi Lagares Roset "jlagares@xtec.cat - www.lagares.org"
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (see the LICENSE file).
 *}

unit UnitFormEntradaDeDades;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TFormEntradaDeDades = class(TForm)
    BitBtnCancelar: TBitBtn;
    BitBtnIniciarEixos: TBitBtn;
    BitBtnFuncioNumerica: TBitBtn;
    BitBtnAjuda: TBitBtn;
    BitBtnAcord: TBitBtn;
    Panel2: TPanel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    EditF: TComboBox;
    EditG: TComboBox;
    EditH: TComboBox;
    EditI: TComboBox;
    EditJ: TComboBox;
    EditK: TComboBox;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label3: TLabel;
    EditOEX: TComboBox;
    EditFEX: TComboBox;
    EditUEX: TComboBox;
    EditOEY: TComboBox;
    EditFEY: TComboBox;
    EditUEY: TComboBox;
    procedure BitBtnIniciarEixosClick(Sender: TObject);
    procedure BitBtnAcordClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure BitBtnFuncioNumericaClick(Sender: TObject);
    procedure BitBtnCancelarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormEntradaDeDades: TFormEntradaDeDades;

{*******************************************************************************}
implementation
{*******************************************************************************}

uses UnitVariables, UnitTools, UnitCalcular, UnitFormPrincipal,
 UnitFormQuinaEsNumerica, UnitCalcularFuncioNumerica, UnitCalcularRegressio;

{$R *.dfm}

{*******************************************************************************}
procedure TFormEntradaDeDades.FormActivate(Sender: TObject);
begin
  FormEntradaDeDades.EditF.SetFocus;
end;

{*******************************************************************************}
procedure TFormEntradaDeDades.BitBtnIniciarEixosClick(Sender: TObject);
begin
  FormEntradaDeDades.EditOEX.Text:=FToSToRealToString(-7.5);
  FormEntradaDeDades.EditUEX.Text:=FToSToRealToString(1);
  FormEntradaDeDades.EditFEX.Text:=FToSToRealToString(7.5);
  FormEntradaDeDades.EditOEY.Text:=FToSToRealToString(-5);
  FormEntradaDeDades.EditUEY.Text:=FToSToRealToString(1);
  FormEntradaDeDades.EditFEY.Text:=FToSToRealToString(5);
end;

  //51/12/12/07 Si calculava els quoeficients de correlaci sempre es quedava en el ltim tipus de regressi si es cancel.lava tot, per la qual cosa donava els clculs malament. Ho he descobert a classe d-estadstica avui
procedure TFormEntradaDeDades.BitBtnCancelarClick(Sender: TObject);
var
  i:integer;
begin
  for i:= 1 to 6 do begin
    FNRegressio[i]:=FNRegressioV[i];
    CoeficientDeCorrelacio[i]:=CoeficientDeCorrelacioV[i];
    TipusRegressio[i]:=TipusRegressioV[i];
  end;
end;
  //51/12/12/07

procedure TFormEntradaDeDades.BitBtnAcordClick(Sender: TObject);
var
  r1,r2:real;
  ErrorCalcul,ErrorAnalisi,LlocError:integer;
begin
  r1:=CalcularCurrency(FormEntradaDeDades.EditOEX.Text,ErrorCalcul);
  if ErrorCalcul=0 then begin
    if FToSToRealToString(r1)<>FormEntradaDeDades.EditOEX.Text then FormEntradaDeDades.EditOEX.Text:=FToSToRealToString(r1);
  end else begin
    Application.MessageBox(PChar(missatges[208]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
    FormEntradaDeDades.EditOEX.SetFocus;
    exit;
  end;
  r2:=CalcularCurrency(FormEntradaDeDades.EditFEX.Text,ErrorCalcul);
  if ErrorCalcul=0 then begin
    if FToSToRealToString(r2)<>FormEntradaDeDades.EditFEX.Text then FormEntradaDeDades.EditFEX.Text:=FToSToRealToString(r2);
  end else begin
    Application.MessageBox(PChar(missatges[209]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
    FormEntradaDeDades.EditFEX.SetFocus;
    exit;
  end;
  if not(r1<r2) then begin
    Application.MessageBox(PChar(missatges[210]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
    FormEntradaDeDades.EditFEX.SetFocus;
    exit;
  end;
  r1:=CalcularCurrency(FormEntradaDeDades.EditUEX.Text,ErrorCalcul);
  if ErrorCalcul=0 then begin
    if r1>0 then begin
      if FToSToRealToString(r1)<>FormEntradaDeDades.EditUEX.Text then FormEntradaDeDades.EditUEX.Text:=FToSToRealToString(r1);
    end else begin
      Application.MessageBox(PChar(missatges[211]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
      FormEntradaDeDades.EditUEX.SetFocus;
      exit;
    end;
  end else begin
    Application.MessageBox(PChar(missatges[212]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
    FormEntradaDeDades.EditUEX.SetFocus;
    exit;
  end;
  r1:=CalcularCurrency(FormEntradaDeDades.EditOEY.Text,ErrorCalcul);
  if ErrorCalcul=0 then begin
    if FToSToRealToString(r1)<>FormEntradaDeDades.EditOEY.Text then FormEntradaDeDades.EditOEY.Text:=FToSToRealToString(r1);
  end else begin
    Application.MessageBox(PChar(missatges[213]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
    //v:22
    FormEntradaDeDades.EditOEY.SetFocus;
    exit;
  end;
  r2:=CalcularCurrency(FormEntradaDeDades.EditFEY.Text,ErrorCalcul);
  if ErrorCalcul=0 then begin
    if FToSToRealToString(r2)<>FormEntradaDeDades.EditFEY.Text then FormEntradaDeDades.EditFEY.Text:=FToSToRealToString(r2);
  end else begin
    Application.MessageBox(PChar(missatges[214]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
    FormEntradaDeDades.EditFEY.SetFocus;
    exit;
  end;
  if not(r1<r2) then begin
    Application.MessageBox(PChar(missatges[215]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
    FormEntradaDeDades.EditFEY.SetFocus;
    exit;
  end;
  r1:=CalcularCurrency(FormEntradaDeDades.EditUEY.Text,ErrorCalcul);
  if ErrorCalcul=0 then begin
    if r1>0 then begin
      if FToSToRealToString(r1)<>FormEntradaDeDades.EditUEY.Text then FormEntradaDeDades.EditUEY.Text:=FToSToRealToString(r1);
    end else begin
      Application.MessageBox(PChar(missatges[216]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
      FormEntradaDeDades.EditUEY.SetFocus;
      exit;
    end;
  end else begin
    Application.MessageBox(PChar(missatges[217]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
    FormEntradaDeDades.EditUEY.SetFocus;
    exit;
  end;
  if FormEntradaDeDades.EditF.Text<>'' then begin
    if not EsFuncioNumerica(FormEntradaDeDades.EditF.Text) then begin
      analitzar(FormEntradaDeDades.EditF.Text,ErrorAnalisi,LlocError);
      if ErrorAnalisi<>0 then begin
        Application.MessageBox(PChar(missatges[218]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        FormEntradaDeDades.EditF.SetFocus;
        exit;
      end;
    end;
  end;
  if FormEntradaDeDades.EditG.Text<>'' then begin
    if not EsFuncioNumerica(FormEntradaDeDades.EditG.Text) then begin
      analitzar(FormEntradaDeDades.EditG.Text,ErrorAnalisi,LlocError);
      if ErrorAnalisi<>0 then begin
        Application.MessageBox(PChar(missatges[219]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        FormEntradaDeDades.EditG.SetFocus;
        exit;
      end;
    end;
  end;
  if FormEntradaDeDades.EditH.Text<>'' then begin
    if not EsFuncioNumerica(FormEntradaDeDades.EditH.Text) then begin
      analitzar(FormEntradaDeDades.EditH.Text,ErrorAnalisi,LlocError);
      if ErrorAnalisi<>0 then begin
        Application.MessageBox(PChar(missatges[220]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        FormEntradaDeDades.EditH.SetFocus;
        exit;
      end;
    end;
  end;
  if FormEntradaDeDades.EditI.Text<>'' then begin
    if not EsFuncioNumerica(FormEntradaDeDades.EditI.Text) then begin
      analitzar(FormEntradaDeDades.EditI.Text,ErrorAnalisi,LlocError);
      if ErrorAnalisi<>0 then begin
        Application.MessageBox(PChar(missatges[221]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        FormEntradaDeDades.EditI.SetFocus;
        exit;
      end;
    end;
  end;
  if FormEntradaDeDades.EditJ.Text<>'' then begin
    if not EsFuncioNumerica(FormEntradaDeDades.EditJ.Text) then begin
      analitzar(FormEntradaDeDades.EditJ.Text,ErrorAnalisi,LlocError);
      if ErrorAnalisi<>0 then begin
        Application.MessageBox(PChar(missatges[222]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        FormEntradaDeDades.EditJ.SetFocus;
        exit;
      end;
    end;
  end;
  if FormEntradaDeDades.EditK.Text<>'' then begin
    if not EsFuncioNumerica(FormEntradaDeDades.EditK.Text) then begin
      analitzar(FormEntradaDeDades.EditK.Text,ErrorAnalisi,LlocError);
      if ErrorAnalisi<>0 then begin
        Application.MessageBox(PChar(missatges[223]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        FormEntradaDeDades.EditK.SetFocus;
        exit;
      end;
    end;
  end;
  ResultatFormEntradaDeDades:=1;
  Close;
end;

procedure TFormEntradaDeDades.BitBtnFuncioNumericaClick(Sender: TObject);
var
  VUX,VUY: real;
  s:string;
begin
  FormQuinaEsNumerica.ShowModal;
  if (ResultatNumericaRegressio<>0) or (ResultatNumericaInterpolacio<>0) then begin
    PrincipiFi(VUX,VUY);
    //s:='            '+missatges[178]+FToSToRealToString(MinX)+'       '+missatges[180]+FToSToRealToString(MinY)+'            '+#10#13#10#13+'            '+missatges[179]+FToSToRealToString(MaxX)+'         '+missatges[181]+FToSToRealToString(MaxY)+'            '+#10#13;
    s:='            '+missatges[178]+RealToStringALillonessima(MinX)+'       '+missatges[180]+RealToStringALillonessima(MinY)+'            '+#10#13#10#13+'            '+missatges[179]+RealToStringALillonessima(MaxX)+'         '+missatges[181]+RealToStringALillonessima(MaxY)+'            '+#10#13;
    if Application.MessageBox(PChar(s),PChar(missatges[249]),MB_YESNO+MB_ICONWARNING+MB_DEFBUTTON1)=idYes then begin
      {
      FormEntradaDeDades.EditOEX.Text:=FToSToRealToString(MinX);
      FormEntradaDeDades.EditFEX.Text:=FToSToRealToString(MaxX);
      FormEntradaDeDades.EditOEY.Text:=FToSToRealToString(MinY);
      FormEntradaDeDades.EditFEY.Text:=FToSToRealToString(MaxY);
      }
      //41 Perqu surten massa decimals
      FormEntradaDeDades.EditOEX.Text:=RealToStringALillonessima(MinX);
      FormEntradaDeDades.EditFEX.Text:=RealToStringALillonessima(MaxX);
      FormEntradaDeDades.EditOEY.Text:=RealToStringALillonessima(MinY);
      FormEntradaDeDades.EditFEY.Text:=RealToStringALillonessima(MaxY);
    end;
  end;
end;

end.

