{*
 * Projecte Fressa a LINKAT
 * FUNCIONS WIN 32
 *
 * Author Jordi Lagares Roset "jlagares@xtec.cat - www.lagares.org"
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (see the LICENSE file).
 *}

unit UnitFormIntegrals;

{*******************************************************************************}
interface
{*******************************************************************************}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TFormIntegrals = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    EditInicial: TEdit;
    LabelX: TLabel;
    EditFinal: TEdit;
    BitBtnContinuar: TBitBtn;
    BitBtn2: TBitBtn;
    procedure BitBtnContinuarClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    HeDActivarFocusXInicial:boolean;
  end;

var
  FormIntegrals: TFormIntegrals;

{*******************************************************************************}
implementation
{*******************************************************************************}

uses UnitFormPrincipal, UnitTools, UnitCalcular, UnitVariables;

{$R *.DFM}

procedure TFormIntegrals.FormCreate(Sender: TObject);
begin
  HeDActivarFocusXInicial:=true;
end;

procedure TFormIntegrals.FormActivate(Sender: TObject);
begin
  Left:=FormPrincipal.Left+4;
  Top:=FormPrincipal.Top+FormPrincipal.Height-FormIntegrals.ClientHeight-4;
  if HeDActivarFocusXInicial then FormIntegrals.EditInicial.SetFocus else HeDActivarFocusXInicial:=true;
end;

procedure TFormIntegrals.BitBtnContinuarClick(Sender: TObject);
var
  x1,x2: Real;
  Errors:integer;
begin
  x1:=CalcularCurrency(EditInicial.Text,Errors);
  if Errors<>0 then begin
    Application.MessageBox(PChar(missatges[200]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
    EditInicial.SetFocus;
    exit;
  end;
  x1:=StrToFloat(RealToStringALillonessima(x1));
  x2:=CalcularCurrency(EditFinal.Text,Errors);
  if Errors<>0 then begin
    Application.MessageBox(PChar(missatges[201]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
    HeDActivarFocusXInicial:=false;
    EditFinal.SetFocus;
    exit;
  end;
  x2:=StrToFloat(RealToStringALillonessima(x2));
  if x1<Oex then begin
    Application.MessageBox(PChar(missatges[18]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
    EditInicial.SetFocus;
    exit;
  end else if x1>Fex then begin
    Application.MessageBox(PChar(missatges[19]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
    EditInicial.SetFocus;
    exit;
  end else if x2<Oex then begin
    Application.MessageBox(PChar(missatges[20]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
    HeDActivarFocusXInicial:=false;
    EditFinal.SetFocus;
    exit;
  end else if x2>Fex then begin
    Application.MessageBox(PChar(missatges[21]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
    HeDActivarFocusXInicial:=false;
    EditFinal.SetFocus;
    exit;
  end else begin
    x1Integral:=x1;
    x2integral:=x2;
    ResultatFormIntegrals:=1;
    Close;
  end;
end;

end.
