{*
 * Projecte Fressa a LINKAT
 * FUNCIONS WIN 32
 *
 * Author Jordi Lagares Roset "jlagares@xtec.cat - www.lagares.org"
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (see the LICENSE file).
 *}

unit UnitFormInterpolacioIntroduirValors;

{*******************************************************************************}
interface
{*******************************************************************************}
{
uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QGrids, QButtons, QExtCtrls;
}
uses
  SysUtils, WinTypes, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, Buttons, ExtCtrls;

type
  TFormNumericaInterpolacio = class(TForm)
    StringGridValorsNumerica: TStringGrid;
    BitBtnSeguent: TBitBtn;
    BitBtnAnterior: TBitBtn;
    BitBtnInserir: TBitBtn;
    BitBtnSuprimir: TBitBtn;
    BitBtnIniciar: TBitBtn;
    BitBtnEnganxar: TBitBtn;
    BitBtnCopiar: TBitBtn;
    BitBtnDAcord: TBitBtn;
    BitBtnCancelar: TBitBtn;
    BitBtnAjuda: TBitBtn;
    CheckBoxLineal: TCheckBox;
    CheckBoxMostrarPunts: TCheckBox;
    CheckBoxExtrapolar: TCheckBox;
    Panel1: TPanel;
    Panel2: TPanel;
    Bevel1: TBevel;
    MemoClipboard: TMemo;
    CheckBoxNomesPunts: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure StringGridValorsNumericaKeyPress(Sender: TObject;var Key: Char);
    procedure BitBtnDAcordClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure BitBtnSeguentClick(Sender: TObject);
    procedure BitBtnAnteriorClick(Sender: TObject);
    procedure BitBtnInserirClick(Sender: TObject);
    procedure BitBtnSuprimirClick(Sender: TObject);
    procedure BitBtnIniciarClick(Sender: TObject);
    procedure BitBtnCopiarClick(Sender: TObject);
    procedure BitBtnEnganxarClick(Sender: TObject);
    procedure CheckBoxNomesPuntsClick(Sender: TObject);
    procedure CheckBoxMostrarPuntsClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Function CalcularUltimLLoc:integer;
  end;

var
  FormNumericaInterpolacio: TFormNumericaInterpolacio;

{*******************************************************************************}
implementation
{*******************************************************************************}

uses UnitCalcular, UnitFormEntradaDeDades, UnitVariables, Clipbrd,
  UnitFormPrincipal;

{$R *.dfm}

procedure TFormNumericaInterpolacio.FormCreate(Sender: TObject);
var
  i:integer;
begin
  StringGridValorsNumerica.ColWidths[0]:=StringGridValorsNumerica.ColWidths[0]-35;
  StringGridValorsNumerica.Cells[1,0]:='X';
  StringGridValorsNumerica.Cells[2,0]:='F(x)';
  for i:=1 to 500 do StringGridValorsNumerica.Cells[0,i]:=IntToStr(i);
end;

procedure TFormNumericaInterpolacio.FormActivate(Sender: TObject);
begin
  StringGridValorsNumerica.SetFocus;
end;

{*******************************************************************************}
procedure TFormNumericaInterpolacio.StringGridValorsNumericaKeyPress(Sender: TObject; var Key: Char);
begin
  if (Ord(Key)=13) {or (Ord(Key)=9)} then begin
    if StringGridValorsNumerica.Col=1 then begin
      StringGridValorsNumerica.Col:=2;
    end else begin
      if StringGridValorsNumerica.Row<500 then begin
        StringGridValorsNumerica.Col:=1;
        StringGridValorsNumerica.Row:=StringGridValorsNumerica.Row+1;
      end;
    end;
  end;
end;

{*******************************************************************************}
procedure TFormNumericaInterpolacio.BitBtnSeguentClick(Sender: TObject);
begin
  if StringGridValorsNumerica.Col=1 then begin
    StringGridValorsNumerica.Col:=2;
  end else begin
    if StringGridValorsNumerica.Row<500 then begin
      StringGridValorsNumerica.Col:=1;
      StringGridValorsNumerica.Row:=StringGridValorsNumerica.Row+1;
    end;
  end;
  StringGridValorsNumerica.SetFocus;
end;

procedure TFormNumericaInterpolacio.BitBtnAnteriorClick(Sender: TObject);
begin
  if StringGridValorsNumerica.Col=2 then begin
    StringGridValorsNumerica.Col:=1;
  end else begin
    if StringGridValorsNumerica.Row>1 then begin
      StringGridValorsNumerica.Col:=2;
      StringGridValorsNumerica.Row:=StringGridValorsNumerica.Row-1;
    end;
  end;
  StringGridValorsNumerica.SetFocus;
end;

procedure TFormNumericaInterpolacio.BitBtnInserirClick(Sender: TObject);
var
  i:integer;
begin
  if StringGridValorsNumerica.Row<500 then begin
    for i:=499 downto StringGridValorsNumerica.Row do begin
      StringGridValorsNumerica.Cells[1,i+1]:=StringGridValorsNumerica.Cells[1,i];
      StringGridValorsNumerica.Cells[2,i+1]:=StringGridValorsNumerica.Cells[2,i];
    end;
    StringGridValorsNumerica.Cells[1,StringGridValorsNumerica.Row]:='';
    StringGridValorsNumerica.Cells[2,StringGridValorsNumerica.Row]:='';
  end;
  StringGridValorsNumerica.Col:=1;
  StringGridValorsNumerica.SetFocus;
end;

procedure TFormNumericaInterpolacio.BitBtnSuprimirClick(Sender: TObject);
var
  i:integer;
begin
  for i:=StringGridValorsNumerica.Row to 499 do begin
    StringGridValorsNumerica.Cells[1,i]:=StringGridValorsNumerica.Cells[1,i+1];
    StringGridValorsNumerica.Cells[2,i]:=StringGridValorsNumerica.Cells[2,i+1];
  end;
  StringGridValorsNumerica.Cells[1,500]:='';
  StringGridValorsNumerica.Cells[2,500]:='';
  StringGridValorsNumerica.Col:=1;
  StringGridValorsNumerica.SetFocus;
end;

procedure TFormNumericaInterpolacio.BitBtnIniciarClick(Sender: TObject);
var
  i:integer;
begin
  if Application.MessageBox(PChar(missatges[224]),PChar(CaptionFuncions),MB_YESNO+MB_ICONQUESTION)=idYes then begin
    for i:=1 to 500 do begin
      StringGridValorsNumerica.Cells[1,i]:='';
      StringGridValorsNumerica.Cells[2,i]:='';
    end;
  end;
  StringGridValorsNumerica.Col:=1;
  StringGridValorsNumerica.Row:=1;
  StringGridValorsNumerica.SetFocus;
end;

Function TFormNumericaInterpolacio.CalcularUltimLLoc:integer;
var
  i:integer;
begin
  CalcularUltimLLoc:=0;
  for i:=1 to 500 do if (StringGridValorsNumerica.Cells[1,i]<>'') or (StringGridValorsNumerica.Cells[2,i]<>'') then CalcularUltimLLoc:=i;
end;

procedure TFormNumericaInterpolacio.BitBtnCopiarClick(Sender: TObject);
var
  i,UltimLloc:integer;
begin
  UltimLloc:=CalcularUltimLLoc;
  if UltimLloc>0 then begin
    MemoClipboard.Clear;
    //MemoClipboard.Text:='X'+#9+'F(X)';
    for i:=1 to UltimLloc do MemoClipboard.Lines.Append(StringGridValorsNumerica.Cells[1,i]+#9+StringGridValorsNumerica.Cells[2,i]);
    {
    MemoClipboard.SelectAll;
    MemoClipboard.CopyToClipboard;
    }
    Clipboard.AsText:=MemoClipboard.Text;
  end;
  StringGridValorsNumerica.SetFocus;
end;

procedure TFormNumericaInterpolacio.BitBtnEnganxarClick(Sender: TObject);
var
  s1:string;
  i,n,UltimLloc:integer;
  VaDeDosAmbDos:boolean;
begin
  if Application.MessageBox(PChar(missatges[225]),PChar(CaptionFuncions),MB_YESNO+MB_ICONQUESTION)=idYes then begin
    StringGridValorsNumerica.SetFocus;
    MemoClipboard.Clear;
    //MemoClipboard.PasteFromClipboard;
    MemoClipboard.Text:=Clipboard.AsText;
    if MemoClipboard.Text='' then begin
      Application.MessageBox(PChar(missatges[226]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
      exit;
    end;
    //37
    for i:=0 to MemoClipboard.Lines.Count do begin
      StringGridValorsNumerica.Cells[1,i+1]:='';
      StringGridValorsNumerica.Cells[2,i+1]:='';
    end;
    //37
    VaDeDosAmbDos:=true;
    for i:=0 to MemoClipboard.Lines.Count do begin
      s1:=MemoClipboard.Lines[i];
      if s1<>'' then begin
        n:=Pos(#9,s1);
        if n=0 then begin
          //Application.MessageBox(PChar(missatges[227]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
          VaDeDosAmbDos:=false;
          break;
        end else begin
          StringGridValorsNumerica.Cells[1,i+1]:=Copy(s1,1,n-1);
          StringGridValorsNumerica.Cells[2,i+1]:=Copy(s1,n+1,length(s1)-n);
        end;
      end else begin
        break;
      end;
    end;
    if not(VaDeDosAmbDos) then begin
      for i:=0 to MemoClipboard.Lines.Count do begin
        StringGridValorsNumerica.Cells[1,i+1]:='';
        StringGridValorsNumerica.Cells[2,i+1]:='';
      end;
      for i:=0 to MemoClipboard.Lines.Count do begin
        s1:=MemoClipboard.Lines[i];
        if s1<>'' then begin
          if i mod 2=0 then begin
            StringGridValorsNumerica.Cells[1,(i+2)div 2]:=s1;
          end else begin
            StringGridValorsNumerica.Cells[2,(i+1)div 2]:=s1;
          end;
        end else begin
          break;
        end;
      end;
    end;

    UltimLloc:=CalcularUltimLLoc;
    StringGridValorsNumerica.Col:=1;
    if UltimLloc=500 then StringGridValorsNumerica.Row:=UltimLloc else StringGridValorsNumerica.Row:=UltimLloc+1;
  end;
  StringGridValorsNumerica.SetFocus;
end;

{*******************************************************************************}
procedure TFormNumericaInterpolacio.BitBtnDAcordClick(Sender: TObject);
var
  i,n:integer;
  r0,r1,r2:real;
  ErrorCalcul:integer;
begin
  for i:=1 to NumericaMax do begin
    if StringGridValorsNumerica.Cells[1,i]<>'' then begin
      r1:=CalcularCurrency(StringGridValorsNumerica.Cells[1,i],ErrorCalcul);
      if ErrorCalcul<>0 then begin
        StringGridValorsNumerica.Col:=1;
        StringGridValorsNumerica.Row:=i;
        Application.MessageBox(PChar(missatges[228]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        StringGridValorsNumerica.SetFocus;
        exit;
      end;
      r2:=CalcularCurrency(StringGridValorsNumerica.Cells[2,i],ErrorCalcul);
      if ErrorCalcul<>0 then begin
        StringGridValorsNumerica.Col:=2;
        StringGridValorsNumerica.Row:=i;
        Application.MessageBox(PChar(missatges[228]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        StringGridValorsNumerica.SetFocus;
        exit;
      end;
      FnP[1,i]:=r1;
      FnP[2,i]:=r2;
      if i>1 then begin
        //56
        //if r1<r0 then begin
        if r1<=r0 then begin
          StringGridValorsNumerica.Col:=1;
          StringGridValorsNumerica.Row:=i;
          Application.MessageBox(PChar(missatges[229]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
          StringGridValorsNumerica.SetFocus;
          exit;
        end;
      end;
      r0:=r1;
    end else begin
      if i<3 then begin
        StringGridValorsNumerica.Col:=1;
        StringGridValorsNumerica.Row:=1;
        Application.MessageBox(PChar(missatges[230]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
        StringGridValorsNumerica.SetFocus;
        exit;
      end;
      for n:=i to NumericaMax do begin
        if (StringGridValorsNumerica.Cells[1,n]<>'') then begin
          StringGridValorsNumerica.Col:=1;
          StringGridValorsNumerica.Row:=n;
          Application.MessageBox(PChar(missatges[231]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
          StringGridValorsNumerica.SetFocus;
          exit;
        end else if (StringGridValorsNumerica.Cells[2,n]<>'') then begin
          StringGridValorsNumerica.Col:=2;
          StringGridValorsNumerica.Row:=n;
          Application.MessageBox(PChar(missatges[231]),PChar(CaptionFuncions),MB_OK+MB_ICONINFORMATION);
          StringGridValorsNumerica.SetFocus;
          exit;
        end;
      end;
      break;
    end;
  end;
  if i=Numericamax then Ul:=i else Ul:=i-1;
  MaximX[Qfn]:=FnP[1,1];
  MinimX[Qfn]:=FnP[1,1];
  MaximY[Qfn]:=FnP[2,1];
  MinimY[Qfn]:=FnP[2,1];
  for n:=2 to Ul do begin
    if FnP[1,n]>MaximX[Qfn] then MaximX[Qfn]:=FnP[1,n];
    if FnP[1,n]<MinimX[Qfn] then MinimX[Qfn]:=FnP[1,n];
    if FnP[2,n]>MaximY[Qfn] then MaximY[Qfn]:=FnP[2,n];
    if FnP[2,n]<MinimY[Qfn] then MinimY[Qfn]:=FnP[2,n];
  end;
  Lloc[Qfn]:=Ll;
  UltimLloc[Qfn]:=Ul;
  if CheckBoxLineal.Checked then EsLineal[Qfn]:=true else EsLineal[Qfn]:=false;
  if CheckBoxMostrarPunts.Checked then EsDibuixarPunts[Qfn]:=true else EsDibuixarPunts[Qfn]:=false;
  if CheckBoxExtrapolar.Checked then EsExtrapolar[Qfn]:=true else EsExtrapolar[Qfn]:=false;
  FNB[Qfn]:=true;
  for i:=1 to NumericaMax do begin
    FN[Qfn,1,i]:=FnP[1,i];
    FN[Qfn,2,i]:=FnP[2,i];
  end;
  if CheckBoxLineal.Checked then begin
    if Qfn=1 then begin
      FormEntradaDeDades.EditF.Text:=FunInterLin;
    end else if Qfn=2 then begin
      FormEntradaDeDades.EditG.Text:=FunInterLin;
    end else if Qfn=3 then begin
      FormEntradaDeDades.EditH.Text:=FunInterLin;
    end else if Qfn=4 then begin
      FormEntradaDeDades.EditI.Text:=FunInterLin;
    end else if Qfn=5 then begin
      FormEntradaDeDades.EditJ.Text:=FunInterLin;
    end else if Qfn=6 then begin
      FormEntradaDeDades.EditK.Text:=FunInterLin;
    end;
  end else begin
    if Qfn=1 then begin
      FormEntradaDeDades.EditF.Text:=FunNumerica;
    end else if Qfn=2 then begin
      FormEntradaDeDades.EditG.Text:=FunNumerica;
    end else if Qfn=3 then begin
      FormEntradaDeDades.EditH.Text:=FunNumerica;
    end else if Qfn=4 then begin
      FormEntradaDeDades.EditI.Text:=FunNumerica;
    end else if Qfn=5 then begin
      FormEntradaDeDades.EditJ.Text:=FunNumerica;
    end else if Qfn=6 then begin
      FormEntradaDeDades.EditK.Text:=FunNumerica;
    end;
  end;
  ResultatNumericaInterpolacio:=1;
  Close;
end;

procedure TFormNumericaInterpolacio.CheckBoxNomesPuntsClick(Sender: TObject);
begin
  if CheckBoxNomesPunts.checked=false then begin
    FormPrincipal.MenuNomsPunts.Checked:=false;
  end else begin
    CheckBoxMostrarPunts.checked:=true;
    FormPrincipal.MenuNomsPunts.Checked:=true;
  end;
end;

procedure TFormNumericaInterpolacio.CheckBoxMostrarPuntsClick(Sender: TObject);
begin
  if CheckBoxMostrarPunts.Checked=false then begin
    CheckBoxNomesPunts.checked:=false;
  end;
end;

end.
