{*
 * Projecte Fressa a LINKAT
 * FUNCIONS WIN 32
 *
 * Author Jordi Lagares Roset "jlagares@xtec.cat - www.lagares.org"
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (see the LICENSE file).
 *}

unit UnitFormQuinaEsNumerica;

{*******************************************************************************}
interface
{*******************************************************************************}

{
uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QExtCtrls, QButtons;
}
uses
  SysUtils, WinTypes, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TFormQuinaEsNumerica = class(TForm)
    GroupBox1: TGroupBox;
    RadioButtonF: TRadioButton;
    RadioButtonG: TRadioButton;
    RadioButtonH: TRadioButton;
    RadioButtonJ: TRadioButton;
    RadioButtonI: TRadioButton;
    RadioButtonK: TRadioButton;
    CheckBoxRegressio: TCheckBox;
    Panel2: TPanel;
    BitBtnDAcord: TBitBtn;
    BitBtnCancelar: TBitBtn;
    procedure BitBtnDAcordClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormQuinaEsNumerica: TFormQuinaEsNumerica;

{*******************************************************************************}
implementation
{*******************************************************************************}

uses UnitVariables, UnitFormInterpolacioIntroduirValors, UnitFormRegressioIntroduirValors, UnitCalcularRegressio, UnitTools;

{$R *.dfm}

procedure TFormQuinaEsNumerica.BitBtnDAcordClick(Sender: TObject);
var
  i,UltimLlocFN:integer;
begin
  if RadioButtonF.Checked then begin
    Qfn:=1;
  end else if RadioButtonG.Checked then begin
    Qfn:=2;
  end else if RadioButtonH.Checked then begin
    Qfn:=4;
  end else if RadioButtonI.Checked then begin
    Qfn:=4;
  end else if RadioButtonG.Checked then begin
    Qfn:=5;
  end else if RadioButtonK.Checked then begin
    Qfn:=6;
  end;
  Ll:=Lloc[Qfn];
  Ul:=UltimLloc[Qfn];
  for i:=1 to NumericaMax do begin
    FnP[1,i]:=FN[Qfn,1,i];
    FnP[2,i]:=FN[Qfn,2,i];
  end;
  if CheckBoxRegressio.Checked then begin
    for i:=1 to NumericaMax do begin
      FormNumericaRegressio.StringGridValorsNumerica.Cells[1,i]:='';
      FormNumericaRegressio.StringGridValorsNumerica.Cells[2,i]:='';
    end;
    if UL>0 then begin
      for i:=1 to UL do begin
        FormNumericaRegressio.StringGridValorsNumerica.Cells[1,i]:=RealToStringALillonessima(FnP[1,i]);
        FormNumericaRegressio.StringGridValorsNumerica.Cells[2,i]:=RealToStringALillonessima(FnP[2,i]);
      end;
    end;
    if TipusRegressio[Qfn]=1 then FormNumericaRegressio.RadioButtonLineal.Checked:=true else FormNumericaRegressio.RadioButtonLineal.Checked:=false;
    if TipusRegressio[Qfn]=2 then FormNumericaRegressio.RadioButtonQuadratica.Checked:=true else FormNumericaRegressio.RadioButtonQuadratica.Checked:=false;
    if TipusRegressio[Qfn]=3 then FormNumericaRegressio.RadioButtonExponencial.Checked:=true else FormNumericaRegressio.RadioButtonExponencial.Checked:=false;
    if TipusRegressio[Qfn]=4 then FormNumericaRegressio.RadioButtonPotencial.Checked:=true else FormNumericaRegressio.RadioButtonPotencial.Checked:=false;
    if TipusRegressio[Qfn]=5 then FormNumericaRegressio.RadioButtonInversa.Checked:=true else FormNumericaRegressio.RadioButtonInversa.Checked:=false;
    UltimLlocFN:=FormNumericaRegressio.CalcularUltimLLoc;
    FormNumericaRegressio.StringGridValorsNumerica.Col:=1;
    if UltimLlocFN=500 then FormNumericaRegressio.StringGridValorsNumerica.Row:=UltimLlocFN else FormNumericaRegressio.StringGridValorsNumerica.Row:=UltimLlocFN+1;
    ResultatNumericaRegressio:=0;
    FormNumericaRegressio.ShowModal;
  end else begin
    for i:=1 to NumericaMax do begin
      FormNumericaInterpolacio.StringGridValorsNumerica.Cells[1,i]:='';
      FormNumericaInterpolacio.StringGridValorsNumerica.Cells[2,i]:='';
    end;
    if UL>0 then begin
      for i:=1 to UL do begin
        FormNumericaInterpolacio.StringGridValorsNumerica.Cells[1,i]:=RealToStringALillonessima(FnP[1,i]);
        FormNumericaInterpolacio.StringGridValorsNumerica.Cells[2,i]:=RealToStringALillonessima(FnP[2,i]);
      end;
    end;
    if EsLineal[Qfn] then FormNumericaInterpolacio.CheckBoxLineal.Checked:=true else FormNumericaInterpolacio.CheckBoxLineal.Checked:=false;
    if EsDibuixarPunts[Qfn] then FormNumericaInterpolacio.CheckBoxMostrarPunts.Checked:=true else FormNumericaInterpolacio.CheckBoxMostrarPunts.Checked:=false;
    if EsExtrapolar[Qfn] then FormNumericaInterpolacio.CheckBoxExtrapolar.Checked:=true else FormNumericaInterpolacio.CheckBoxExtrapolar.Checked:=false;
    UltimLlocFN:=FormNumericaInterpolacio.CalcularUltimLLoc;
    FormNumericaInterpolacio.StringGridValorsNumerica.Col:=1;
    if UltimLlocFN=500 then FormNumericaInterpolacio.StringGridValorsNumerica.Row:=UltimLlocFN else FormNumericaInterpolacio.StringGridValorsNumerica.Row:=UltimLlocFN+1;
    ResultatNumericaInterpolacio:=0;
    FormNumericaInterpolacio.ShowModal;
  end;
end;

end.
